#include "stdafx.h"
#include <shlwapi.h>
#include "DtvEngine.h"
#include "HDUSTest_KeyHook/HDUSTest_KeyHook.h"
#include "Settings.h"
#include "resource.h"


#pragma warning(disable: 4995) // warning C4995: Oꂽ #pragma ƂċLqĂ܂B


#define lengthof(a) (sizeof(a)/sizeof(a[0]))


#define MAIN_WINDOW_CLASS	TEXT("HDUSTest Window")
#define VIEW_WINDOW_CLASS	TEXT("HDUSTest View")
#define STATUS_WINDOW_CLASS	TEXT("HDUSTest Status")

#define TITLE_TEXT TEXT("HDUSTest")

#define STATUS_MARGIN	4

#define FIRST_CHANNEL	13

#define MENU_POS_ZOOM		0
#define MENU_POS_CHANNEL	4
#define MENU_POS_SERVICE	5
#define MENU_POS_SPACE		6
#define MENU_POS_VOLUME		8
#define MENU_POS_STEREOMODE	9

static HINSTANCE hInst;
static HWND hwndMain;
static HWND hwndView;
static HMENU hmenuMain=NULL;
static HACCEL hAccel;

static int WindowLeft=CW_USEDEFAULT;
static int WindowTop=CW_USEDEFAULT;
static int WindowWidth=CW_USEDEFAULT;
static int WindowHeight=CW_USEDEFAULT;
static bool fWindowMaximize=false;
static bool fAlwaysOnTop=false;
static bool fFullscreen=false;

static TCHAR szIniFileName[MAX_PATH];
static TCHAR szDriverFileName[MAX_PATH];
static HMODULE hDriverLib=NULL;

static bool fNoDescramble=false;
static bool fNoKeyHook=false;
static bool fNoRemoteController=false;
static bool fNoScreenSaver=false;
static BOOL fScreenSaverActive;
static bool fNoMonitorLowPower=false;
static bool fRestoreChannel=false;
static int OldChannel=0,OldSpace=-1;

static CDtvEngine DtvEngine;

static int NumSpaces=0;
static int CurrentSpace=0;
static int CurrentChannel=-1;
static int CurrentService=0;
#define MAX_VOLUME 100
static int CurrentVolume=100;
static bool fMute=false;
static int CurrentStereoMode=0;

static int VideoWidth=0;
static int VideoHeight=0;
static int CurrentNumAudioChannels=0;
static bool fRecording=false;
static TCHAR szRecordFileName[MAX_PATH];
static bool fAddRecordTime=false;

static COLORREF crStatusBkColor=RGB(128,192,160);
static COLORREF crStatusTextColor=RGB(64,96,80);

static POINT ptDragStartPos;
static RECT rcDragStart;




static bool LoadSettings()
{
	Settings Setting;

	if (Setting.Open(szIniFileName,TEXT("Settings"),Settings::OPEN_READ)) {
		int Value;

		Setting.Read(TEXT("WindowLeft"),&WindowLeft);
		Setting.Read(TEXT("WindowTop"),&WindowTop);
		Setting.Read(TEXT("WindowWidth"),&WindowWidth);
		Setting.Read(TEXT("WindowHeight"),&WindowHeight);
		Setting.Read(TEXT("WindowMaximize"),&fWindowMaximize);
		Setting.Read(TEXT("AlwaysOnTop"),&fAlwaysOnTop);
		Setting.Read(TEXT("Driver"),szDriverFileName,
												lengthof(szDriverFileName));
		if (Setting.Read(TEXT("Volume"),&Value))
			CurrentVolume=Value<0?0:Value>MAX_VOLUME?MAX_VOLUME:Value;
		Setting.Read(TEXT("RecordFile"),szRecordFileName,
												lengthof(szRecordFileName));
		Setting.Read(TEXT("AddRecordTime"),&fAddRecordTime);
		Setting.ReadColor(TEXT("StatusBkColor"),&crStatusBkColor);
		Setting.ReadColor(TEXT("StatusTextColor"),&crStatusTextColor);
		Setting.Read(TEXT("NoKeyHook"),&fNoKeyHook);
		Setting.Read(TEXT("NoRemoteController"),&fNoRemoteController);
		Setting.Read(TEXT("NoScreenSaver"),&fNoScreenSaver);
		Setting.Read(TEXT("NoMonitorLowPower"),&fNoMonitorLowPower);
		Setting.Read(TEXT("RestoreChannel"),&fRestoreChannel);
		Setting.Read(TEXT("CurChannel"),&OldChannel);
		Setting.Read(TEXT("CurSpace"),&OldSpace);
		Setting.Close();
		return true;
	}
	return false;
}


static bool SaveSettings()
{
	Settings Setting;

	if (Setting.Open(szIniFileName,TEXT("Settings"),Settings::OPEN_WRITE)) {
		int Value;

		Setting.Write(TEXT("WindowLeft"),WindowLeft);
		Setting.Write(TEXT("WindowTop"),WindowTop);
		Setting.Write(TEXT("WindowWidth"),WindowWidth);
		Setting.Write(TEXT("WindowHeight"),WindowHeight);
		Setting.Write(TEXT("WindowMaximize"),fWindowMaximize);
		Setting.Write(TEXT("AlwaysOnTop"),fAlwaysOnTop);
		//Setting.Write(TEXT("Driver"),szDriverFileName);
		Setting.Write(TEXT("Volume"),CurrentVolume);
		Setting.Write(TEXT("RecordFile"),szRecordFileName);
		Setting.Write(TEXT("AddRecordTime"),fAddRecordTime);
		Setting.Write(TEXT("CurChannel"),OldChannel);
		Setting.Write(TEXT("CurSpace"),OldSpace);
		Setting.Close();
		return true;
	}
	return false;
}


static float LevelToDeciBel(int Level)
{
	float Volume;

	if (Level==0)
		Volume=-100.0f;
	else
		Volume=(float)(20.0*log10((double)Level/100.0));
	return Volume;
}


static void AdjustAspect(int *pWidth,int *pHeight,int XAspect,int YAspect)
{
	int Width=*pWidth,Height=*pHeight;
	double SrcAspect,DstAspect;

	SrcAspect=(double)Width/(double)Height;
	DstAspect=(double)XAspect/(double)YAspect;
	if (SrcAspect<DstAspect)
		Height=Width*YAspect/XAspect;
	else if (SrcAspect>DstAspect)
		Width=Height*XAspect/YAspect;
	*pWidth=Width;
	*pHeight=Height;
}




#define MAX_CHANNEL_NAME 32


class CChannelInfo {
public:
	CChannelInfo(int Space,int Channel,int No,LPCTSTR pszName);
	int m_Space;
	int m_Channel;
	int m_ChannelNo;
	TCHAR m_szName[MAX_CHANNEL_NAME];
};


CChannelInfo::CChannelInfo(int Space,int Channel,int No,LPCTSTR pszName)
{
	m_Space=Space;
	m_Channel=Channel;
	m_ChannelNo=No;
	lstrcpyn(m_szName,pszName,MAX_CHANNEL_NAME);
}




class CChannelList {
	int m_NumChannels;
	CChannelInfo **m_ppList;
public:
	CChannelList();
	~CChannelList();
	int NumChannels() const { return m_NumChannels; }
	bool AddChannel(int Space,int Channel,int No,LPCTSTR pszName);
	int GetSpace(int No) const;
	int GetChannel(int No) const;
	int GetChannelNo(int No) const;
	LPCTSTR GetName(int No) const;
};


CChannelList::CChannelList()
{
	m_NumChannels=0;
	m_ppList=NULL;
}


CChannelList::~CChannelList()
{
	int i;

	for (i=m_NumChannels-1;i>=0;i--)
		delete m_ppList[i];
	free(m_ppList);
}


bool CChannelList::AddChannel(int Space,int Channel,int No,LPCTSTR pszName)
{
	m_ppList=(CChannelInfo**)realloc(m_ppList,
									(m_NumChannels+1)*sizeof(CChannelInfo*));
	m_ppList[m_NumChannels++]=new CChannelInfo(Space,Channel,No,pszName);
	return true;
}


int CChannelList::GetSpace(int No) const
{
	return m_ppList[No]->m_Space;
}


int CChannelList::GetChannel(int No) const
{
	return m_ppList[No]->m_Channel;
}


int CChannelList::GetChannelNo(int No) const
{
	return m_ppList[No]->m_ChannelNo;
}


LPCTSTR CChannelList::GetName(int No) const
{
	return m_ppList[No]->m_szName;
}


static CChannelList ChannelList;


static bool LoadChannelList(LPCTSTR pszFileName)
{
	HANDLE hFile;
	DWORD Size,Read;
	char *pszText,*p,*q;
	TCHAR szName[MAX_CHANNEL_NAME];
	int i;
	int Space,ChannelNo,Channel;

	hFile=CreateFile(pszFileName,GENERIC_READ,FILE_SHARE_READ,NULL,
														OPEN_EXISTING,0,NULL);
	if (hFile==INVALID_HANDLE_VALUE)
		return false;
	Size=GetFileSize(hFile,NULL);
	if (Size==0) {
		CloseHandle(hFile);
		return false;
	}
	pszText=new char[Size+1];
	if (!ReadFile(hFile,pszText,Size,&Read,NULL) || Read!=Size) {
		delete [] pszText;
		CloseHandle(hFile);
		return false;
	}
	CloseHandle(hFile);
	pszText[Size]='\0';
	p=pszText;
	do {
		while (*p=='\r' || *p=='\n')
			p++;
		if (*p=='\0')
			break;
		q=p;
		while (*p!=',' && *p!='\0') {
			if (IsDBCSLeadByteEx(CP_ACP,*p) && *(p+1)!='\0')
				p++;
			p++;
		}
		if (*p!=',')
			break;
		*p++='\0';
#ifdef UNICODE
		MultiByteToWideChar(CP_ACP,0,q,-1,szName,MAX_CHANNEL_NAME);
#else
		lstrcpyn(szName,q,MAX_CHANNEL_NAME);
#endif
		ChannelNo=0;
		while (*p>='0' && *p<='9') {
			ChannelNo=ChannelNo*10+(*p-'0');
			p++;
		}
		if (*p!=',')
			break;
		p++;
		if (*p=='C') {
			Space=1;
			p++;
		} else
			Space=0;
		Channel=0;
		while (*p>='0' && *p<='9') {
			Channel=Channel*10+(*p-'0');
			p++;
		}
		if (ChannelNo>0 && Channel>0)
			ChannelList.AddChannel(Space,Channel,ChannelNo,szName);
		while (*p!='\r' && *p!='\n' && *p!='\0')
			p++;
	} while (*p!='\0');
	return true;
}




class CStatusItem {
protected:
	class CStatusView *m_pStatus;
	int m_Width;
public:
	virtual ~CStatusItem() {}
	virtual void Draw(HDC hdc,const RECT *pRect)=0;
	int Width() const { return m_Width; }
	virtual void OnLButtonDown(int x,int y) {}
	virtual void OnRButtonDown(int x,int y) { OnLButtonDown(x,y); }
	virtual void OnMouseMove(int x,int y) {}
};


class CStatusView {
	HWND m_hwnd;
	HFONT m_hfontStatus;
#define NUM_STATUS_ITEMS 5
	CStatusItem *m_pItemList[5];
	bool m_fSingleMode;
	LPTSTR m_pszSingleText;
	int m_HotItem;
	bool m_fTrackMouseEvent;
	static CStatusView *GetStatusView(HWND hwnd);
	static LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,
												WPARAM wParam,LPARAM lParam);
public:
	static bool Init();
	CStatusView();
	~CStatusView();
	bool Create(HWND hwndParent,int ID,DWORD Style,DWORD ExStyle);
	void UpdateItem(int Index);
	bool GetItemRect(int Index,RECT *pRect);
	void GetRect(RECT *pRect);
	void Move(int x,int y,int Width,int Height);
	HWND GetHandle() const { return m_hwnd; }
	void SetSingleText(LPCTSTR pszText);
};

enum {
	STATUS_ITEM_CHANNEL,
	STATUS_ITEM_VIDEOSIZE,
	STATUS_ITEM_VOLUME,
	STATUS_ITEM_AUDIOCHANNEL,
	STATUS_ITEM_RECORD
};


class CChannelStatusItem : public CStatusItem {
public:
	CChannelStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
};

CChannelStatusItem::CChannelStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=96;
}

void CChannelStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	TCHAR szText[4+MAX_CHANNEL_NAME];

	if (CurrentChannel>=0) {
		wsprintf(szText,TEXT("%d: %s"),
									ChannelList.GetChannelNo(CurrentChannel),
									ChannelList.GetName(CurrentChannel));
	} else
		lstrcpy(szText,TEXT("<`l>"));
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CChannelStatusItem::OnLButtonDown(int x,int y)
{
	RECT rc;
	POINT pt;

	m_pStatus->GetItemRect(STATUS_ITEM_CHANNEL,&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_CHANNEL),
									TPM_LEFTBUTTON,pt.x,pt.y,0,hwndMain,NULL);
}


class CVideoSizeStatusItem : public CStatusItem {
public:
	CVideoSizeStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
};

CVideoSizeStatusItem::CVideoSizeStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=120;
}

void CVideoSizeStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	TCHAR szText[32];
	RECT rc;
	int XZoom,YZoom,Zoom;

	if (VideoWidth>0 && VideoHeight>0) {
		int Width,Height;
		BYTE XAspect,YAspect;

		GetClientRect(hwndView,&rc);
		Width=VideoWidth;
		Height=VideoHeight;
		if (DtvEngine.GetVideoAspectRatio(&XAspect,&YAspect))
			AdjustAspect(&Width,&Height,XAspect,YAspect);
		XZoom=(rc.right*100+Width/2)/Width;
		YZoom=(rc.bottom*100+Height/2)/Height;
		Zoom=min(XZoom,YZoom);
	} else
		Zoom=0;
	wsprintf(szText,TEXT("%d x %d (%d %%)"),VideoWidth,VideoHeight,Zoom);
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CVideoSizeStatusItem::OnLButtonDown(int x,int y)
{
	RECT rc;
	POINT pt;

	m_pStatus->GetItemRect(STATUS_ITEM_VIDEOSIZE,&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_ZOOM),
									TPM_LEFTBUTTON,pt.x,pt.y,0,hwndMain,NULL);
}


class CVolumeStatusItem : public CStatusItem {
public:
	CVolumeStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
	void OnMouseMove(int x,int y);
};

CVolumeStatusItem::CVolumeStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=80;
}

void CVolumeStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	HPEN hpen,hpenOld;
	HBRUSH hbr,hbrOld;
	RECT rc;
	COLORREF crBar;

	hpen=CreatePen(PS_SOLID,1,GetTextColor(hdc));
	hpenOld=(HPEN)SelectObject(hdc,hpen);
	hbrOld=(HBRUSH)SelectObject(hdc,GetStockObject(NULL_BRUSH));
	rc.left=pRect->left;
	rc.top=pRect->top+(pRect->bottom-pRect->top-8)/2;
	rc.right=pRect->right;
	rc.bottom=rc.top+8;
	Rectangle(hdc,rc.left,rc.top,rc.right,rc.bottom);
	SelectObject(hdc,hbrOld);
	SelectObject(hdc,hpenOld);
	DeleteObject(hpen);
	if (!fMute) {
		crBar=GetTextColor(hdc);
	} else {
		COLORREF crText,crBk;

		crText=GetTextColor(hdc);
		crBk=GetBkColor(hdc);
		crBar=RGB((GetRValue(crText)+GetRValue(crBk))/2,
				  (GetGValue(crText)+GetGValue(crBk))/2,
				  (GetBValue(crText)+GetBValue(crBk))/2);
	}
	hbr=CreateSolidBrush(crBar);
	rc.left+=2;
	rc.top+=2;
	rc.right=rc.left+(rc.right-2-rc.left)*CurrentVolume/MAX_VOLUME;
	rc.bottom-=2;
	FillRect(hdc,&rc,hbr);
	DeleteObject(hbr);
}

void CVolumeStatusItem::OnLButtonDown(int x,int y)
{
	OnMouseMove(x,y);
	SetCapture(m_pStatus->GetHandle());
}

void CVolumeStatusItem::OnRButtonDown(int x,int y)
{
	SendMessage(hwndMain,WM_COMMAND,CM_VOLUME_MUTE,0);
}

void CVolumeStatusItem::OnMouseMove(int x,int y)
{
	RECT rc;
	int Volume;

	m_pStatus->GetItemRect(STATUS_ITEM_VOLUME,&rc);
	Volume=(x-2)*100/(rc.right-rc.left-4-1);
	if (Volume<0)
		Volume=0;
	else if (Volume>MAX_VOLUME)
		Volume=MAX_VOLUME;
	if (fMute || Volume!=CurrentVolume) {
		if (fMute) {
			fMute=false;
			CheckMenuItem(hmenuMain,CM_VOLUME_MUTE,
												MF_BYCOMMAND | MFS_UNCHECKED);
		}
		DtvEngine.SetVolume(LevelToDeciBel(Volume));
		CurrentVolume=Volume;
		m_pStatus->UpdateItem(STATUS_ITEM_VOLUME);
	}
}


class CAudioChannelStatusItem : public CStatusItem {
public:
	CAudioChannelStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
};

CAudioChannelStatusItem::CAudioChannelStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=64;
}

void CAudioChannelStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	TCHAR szText[32];

	if (CurrentNumAudioChannels>0) {
		switch (CurrentNumAudioChannels) {
		case 1:
			lstrcpy(szText,TEXT("Mono"));
			break;
		case 2:
			lstrcpy(szText,TEXT("Stereo"));
			if (CurrentStereoMode!=0)
				lstrcat(szText,CurrentStereoMode==1?TEXT("(L)"):TEXT("(R)"));
			break;
		case 6:
			lstrcpy(szText,TEXT("5.1ch"));
			break;
		default:
			wsprintf(szText,TEXT("%dch"),CurrentNumAudioChannels);
			break;
		}
	} else
		lstrcpy(szText,TEXT("<>"));
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CAudioChannelStatusItem::OnLButtonDown(int x,int y)
{
	if (CurrentNumAudioChannels==2)
		SendMessage(hwndMain,WM_COMMAND,CM_STEREOMODE,0);
	else
		OnRButtonDown(x,y);
}

void CAudioChannelStatusItem::OnRButtonDown(int x,int y)
{
	RECT rc;
	POINT pt;

	m_pStatus->GetItemRect(STATUS_ITEM_AUDIOCHANNEL,&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_STEREOMODE),
									TPM_LEFTBUTTON,pt.x,pt.y,0,hwndMain,NULL);
}


class CRecordStatusItem : public CStatusItem {
public:
	CRecordStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
};

CRecordStatusItem::CRecordStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=64;
}

void CRecordStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,fRecording?TEXT(" ^撆"):TEXT(""),-1,
		const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CRecordStatusItem::OnLButtonDown(int x,int y)
{
	SendMessage(hwndMain,WM_COMMAND,CM_RECORD,0);
}

void CRecordStatusItem::OnRButtonDown(int x,int y)
{
	HMENU hmenu;
	RECT rc;
	POINT pt;

	hmenu=LoadMenu(hInst,MAKEINTRESOURCE(IDM_RECORD));
	CheckMenuItem(hmenu,CM_ADDRECORDTIME,
					MF_BYCOMMAND | (fAddRecordTime?MFS_CHECKED:MFS_UNCHECKED));
	m_pStatus->GetItemRect(STATUS_ITEM_RECORD,&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetSubMenu(hmenu,0),TPM_LEFTBUTTON,pt.x,pt.y,0,hwndMain,
																		NULL);
	DestroyMenu(hmenu);
}




bool CStatusView::Init()
{
	WNDCLASS wc;

	wc.style=0;
	wc.lpfnWndProc=WndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=NULL;
	wc.lpszMenuName=NULL;
	wc.lpszClassName=STATUS_WINDOW_CLASS;
	return RegisterClass(&wc)!=0;
}


CStatusView::CStatusView()
{
	m_hwnd=NULL;
	m_hfontStatus=NULL;
	m_pItemList[0]=new CChannelStatusItem(this);
	m_pItemList[1]=new CVideoSizeStatusItem(this);
	m_pItemList[2]=new CVolumeStatusItem(this);
	m_pItemList[3]=new CAudioChannelStatusItem(this);
	m_pItemList[4]=new CRecordStatusItem(this);
	m_fSingleMode=false;
	m_pszSingleText=NULL;
	m_HotItem=-1;
	m_fTrackMouseEvent=false;
}


CStatusView::~CStatusView()
{
	if (m_hwnd!=NULL)
		DestroyWindow(m_hwnd);
	for (int i=0;i<NUM_STATUS_ITEMS;i++)
		delete m_pItemList[i];
	delete [] m_pszSingleText;
}


bool CStatusView::Create(HWND hwndParent,int ID,DWORD Style,DWORD ExStyle)
{
	m_hwnd=CreateWindowEx(ExStyle,STATUS_WINDOW_CLASS,NULL,Style,
									0,0,0,0,hwndParent,(HMENU)ID,hInst,this);
	return m_hwnd!=NULL;
}


CStatusView *CStatusView::GetStatusView(HWND hwnd)
{
	return (CStatusView*)GetWindowLongPtr(hwnd,GWLP_USERDATA);
}


LRESULT CALLBACK CStatusView::WndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		{
			LPCREATESTRUCT pcs=(LPCREATESTRUCT)lParam;
			CStatusView *pStatus;
			LOGFONT lf;
			HDC hdc;
			HFONT hfontOld;
			TEXTMETRIC tm;
			RECT rc;

			pStatus=(CStatusView*)pcs->lpCreateParams;
			SetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR)pStatus);
			GetObject(GetStockObject(DEFAULT_GUI_FONT),sizeof(LOGFONT),&lf);
			pStatus->m_hfontStatus=CreateFontIndirect(&lf);
			hdc=GetDC(hwnd);
			hfontOld=(HFONT)SelectObject(hdc,pStatus->m_hfontStatus);
			GetTextMetrics(hdc,&tm);
			SelectObject(hdc,hfontOld);
			ReleaseDC(hwnd,hdc);
			rc.left=0;
			rc.top=0;
			rc.right=0;
			rc.bottom=tm.tmHeight+STATUS_MARGIN*2;
			AdjustWindowRectEx(&rc,pcs->style,FALSE,pcs->dwExStyle);
			MoveWindow(hwnd,0,0,0,rc.bottom-rc.top,FALSE);
		}
		return 0;

	case WM_PAINT:
		{
			CStatusView *pStatus=GetStatusView(hwnd);
			PAINTSTRUCT ps;
			HBRUSH hbrBk,hbrHighlight;
			HFONT hfontOld;
			COLORREF crOldTextColor,crOldBkColor;
			int OldBkMode;
			RECT rc;
			TCHAR szText[64];
			int i;
			int x;

			BeginPaint(hwnd,&ps);
			hfontOld=(HFONT)SelectObject(ps.hdc,pStatus->m_hfontStatus);
			OldBkMode=SetBkMode(ps.hdc,TRANSPARENT);
			hbrBk=CreateSolidBrush(crStatusBkColor);
			if (pStatus->m_HotItem>=0)
				hbrHighlight=CreateSolidBrush(crStatusTextColor);
			else
				hbrHighlight=NULL;
			crOldTextColor=GetTextColor(ps.hdc);
			crOldBkColor=GetBkColor(ps.hdc);
			GetClientRect(hwnd,&rc);
			if (pStatus->m_fSingleMode) {
				FillRect(ps.hdc,&ps.rcPaint,hbrBk);
				SetTextColor(ps.hdc,crStatusTextColor);
				rc.left+=STATUS_MARGIN;
				DrawText(ps.hdc,pStatus->m_pszSingleText,-1,&rc,
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
			} else {
				for (i=0;i<NUM_STATUS_ITEMS;i++) {
					SetTextColor(ps.hdc,i==pStatus->m_HotItem?
										crStatusBkColor:crStatusTextColor);
					SetBkColor(ps.hdc,i==pStatus->m_HotItem?
										crStatusTextColor:crStatusBkColor);
					rc.right=rc.left+pStatus->m_pItemList[i]->Width()+
															STATUS_MARGIN*2;
					FillRect(ps.hdc,&rc,i==pStatus->m_HotItem?hbrHighlight:hbrBk);
					rc.left+=STATUS_MARGIN;
					rc.right-=STATUS_MARGIN;
					pStatus->m_pItemList[i]->Draw(ps.hdc,&rc);
					rc.left=rc.right+STATUS_MARGIN;
				}
				rc.right=ps.rcPaint.right;
				if (rc.right>rc.left)
					FillRect(ps.hdc,&rc,hbrBk);
			}
			DeleteObject(hbrBk);
			if (hbrHighlight!=NULL)
				DeleteObject(hbrHighlight);
			SetBkColor(ps.hdc,crOldBkColor);
			SetTextColor(ps.hdc,crOldTextColor);
			SetBkMode(ps.hdc,OldBkMode);
			SelectObject(ps.hdc,hfontOld);
			EndPaint(hwnd,&ps);
		}
		return 0;

	case WM_MOUSEMOVE:
		if (GetCapture()==hwnd) {
			CStatusView *pStatus=GetStatusView(hwnd);
			int x=GET_X_LPARAM(lParam),y=GET_Y_LPARAM(lParam);
			RECT rc;

			pStatus->GetItemRect(pStatus->m_HotItem,&rc);
			x-=rc.left;
			pStatus->m_pItemList[pStatus->m_HotItem]->OnMouseMove(x,y);
		} else {
			CStatusView *pStatus=GetStatusView(hwnd);
			int x=GET_X_LPARAM(lParam);
			int Left,Right;
			int i;

			Left=0;
			for (i=0;i<NUM_STATUS_ITEMS;i++) {
				Right=Left+STATUS_MARGIN*2+pStatus->m_pItemList[i]->Width();
				if (x>=Left && x<Right)
					break;
				Left=Right;
			}
			if (i==NUM_STATUS_ITEMS)
				i=-1;
			if (i!=pStatus->m_HotItem) {
				int OldHotItem;

				OldHotItem=pStatus->m_HotItem;
				pStatus->m_HotItem=i;
				if (OldHotItem>=0)
					pStatus->UpdateItem(OldHotItem);
				if (pStatus->m_HotItem>=0)
					pStatus->UpdateItem(pStatus->m_HotItem);
			}
			if (!pStatus->m_fTrackMouseEvent) {
				TRACKMOUSEEVENT tme;

				tme.cbSize=sizeof(TRACKMOUSEEVENT);
				tme.dwFlags=TME_LEAVE;
				tme.hwndTrack=hwnd;
				if (TrackMouseEvent(&tme))
					pStatus->m_fTrackMouseEvent=true;
			}
		}
		return 0;

	case WM_MOUSELEAVE:
		{
			CStatusView *pStatus=GetStatusView(hwnd);

			if (pStatus->m_HotItem>=0) {
				int i=pStatus->m_HotItem;

				pStatus->m_HotItem=-1;
				pStatus->UpdateItem(i);
			}
			pStatus->m_fTrackMouseEvent=false;
		}
		return 0;

	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
		{
			CStatusView *pStatus=GetStatusView(hwnd);

			if (pStatus->m_HotItem>=0) {
				int x=GET_X_LPARAM(lParam),y=GET_Y_LPARAM(lParam);
				RECT rc;

				pStatus->GetItemRect(pStatus->m_HotItem,&rc);
				x-=rc.left;
				if (uMsg==WM_LBUTTONDOWN)
					pStatus->m_pItemList[pStatus->m_HotItem]->OnLButtonDown(x,y);
				else
					pStatus->m_pItemList[pStatus->m_HotItem]->OnRButtonDown(x,y);
			}
		}
		return 0;

	case WM_LBUTTONUP:
		if (GetCapture()==hwnd) {
			ReleaseCapture();
		}
		return 0;

	case WM_SETCURSOR:
		if (LOWORD(lParam)==HTCLIENT) {
			CStatusView *pStatus=GetStatusView(hwnd);

			if (pStatus->m_HotItem>=0) {
				SetCursor(LoadCursor(NULL,IDC_HAND));
				return TRUE;
			}
		}
		break;

	case WM_DESTROY:
		{
			CStatusView *pStatus=GetStatusView(hwnd);

			DeleteObject(pStatus->m_hfontStatus);
			pStatus->m_hwnd=NULL;
		}
		return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


void CStatusView::UpdateItem(int Index)
{
	RECT rc;

	GetItemRect(Index,&rc);
	InvalidateRect(m_hwnd,&rc,TRUE);
}


bool CStatusView::GetItemRect(int Index,RECT *pRect)
{
	int i;
	RECT rc;

	GetClientRect(m_hwnd,&rc);
	for (i=0;i<Index;i++)
		rc.left+=m_pItemList[i]->Width()+STATUS_MARGIN*2;
	rc.right=rc.left+m_pItemList[i]->Width()+STATUS_MARGIN*2;
	*pRect=rc;
	return true;
}


void CStatusView::GetRect(RECT *pRect)
{
	GetWindowRect(m_hwnd,pRect);
}


void CStatusView::Move(int x,int y,int Width,int Height)
{
	MoveWindow(m_hwnd,x,y,Width,Height,TRUE);
}


void CStatusView::SetSingleText(LPCTSTR pszText)
{
	delete [] m_pszSingleText;
	if (pszText!=NULL) {
		m_pszSingleText=new TCHAR[lstrlen(pszText)+1];
		lstrcpy(m_pszSingleText,pszText);
		m_fSingleMode=true;
	} else {
		m_pszSingleText=NULL;
		m_fSingleMode=false;
	}
	InvalidateRect(m_hwnd,NULL,TRUE);
}


static CStatusView Status;




class CKeyHook {
	HMODULE m_hLib;
	bool m_fHook;
	UINT m_Message;
public:
	CKeyHook();
	~CKeyHook();
	bool BeginHook();
	bool EndHook();
	bool TranslateMessage(UINT uMsg,WPARAM wParam,LPARAM lParam);
};

CKeyHook::CKeyHook()
{
	m_hLib=NULL;
	m_fHook=false;
	m_Message=WM_NULL;
}

CKeyHook::~CKeyHook()
{
	if (m_hLib!=NULL) {
		EndHook();
		FreeLibrary(m_hLib);
	}
}

bool CKeyHook::BeginHook()
{
	BeginHookFunc pBeginHook;

	if (m_hLib==NULL) {
		m_hLib=LoadLibrary(TEXT("HDUSTest_KeyHook.dll"));
		if (m_hLib==NULL)
			return false;
	}
	pBeginHook=(BeginHookFunc)GetProcAddress(m_hLib,"BeginHook");
	if (pBeginHook==NULL || !pBeginHook(hwndMain))
		return false;
	m_fHook=true;
	m_Message=RegisterWindowMessage(KEYHOOK_MESSAGE);

	// Vista ŊǗҌŎsꂽp̑΍
#ifndef MSGFLT_ADD
#define MSGFLT_ADD 1
#endif
	typedef BOOL (WINAPI *ChangeWindowMessageFilterFunc)(UINT,DWORD);
	HMODULE hLib=LoadLibrary(TEXT("user32.dll"));
	ChangeWindowMessageFilterFunc pChangeFilter=(ChangeWindowMessageFilterFunc)
							GetProcAddress(hLib,"ChangeWindowMessageFilter");

	if (pChangeFilter!=NULL)
		pChangeFilter(m_Message,MSGFLT_ADD);
	FreeLibrary(hLib);
	return true;
}

bool CKeyHook::EndHook()
{
	if (m_fHook) {
		EndHookFunc pEndHook;

		pEndHook=(EndHookFunc)GetProcAddress(m_hLib,"EndHook");
		if (pEndHook==NULL)
			return false;
		pEndHook();
		m_fHook=false;
	}
	return true;
}

bool CKeyHook::TranslateMessage(UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static const struct {
		WORD Key;
		WORD Modifier;
		int Command;
	} KeyMap[] = {
		{VK_F17,	MK_SHIFT,	CM_CHANNELNO_1},
		{VK_F18,	MK_SHIFT,	CM_CHANNELNO_2},
		{VK_F19,	MK_SHIFT,	CM_CHANNELNO_3},
		{VK_F20,	MK_SHIFT,	CM_CHANNELNO_4},
		{VK_F21,	MK_SHIFT,	CM_CHANNELNO_5},
		{VK_F22,	MK_SHIFT,	CM_CHANNELNO_6},
		{VK_F23,	MK_SHIFT,	CM_CHANNELNO_7},
		{VK_F24,	MK_SHIFT,	CM_CHANNELNO_8},
		{VK_F13,	MK_CONTROL,	CM_CHANNELNO_9},
		{VK_F16,	MK_SHIFT,	CM_CHANNELNO_10},
		{VK_F14,	MK_CONTROL,	CM_CHANNELNO_11},
		{VK_F15,	MK_CONTROL,	CM_CHANNELNO_12},
		{VK_F15,	MK_SHIFT,	CM_VOLUME_MUTE},
		{VK_F14,	MK_SHIFT,	CM_EXIT},
		{VK_F16,	MK_CONTROL,	CM_MENU},
		{VK_F17,	MK_CONTROL,	CM_FULLSCREEN},
		{VK_F19,	MK_CONTROL,	CM_STEREOMODE},
		{VK_F22,	MK_CONTROL,	CM_RECORD_START},
		{VK_F24,	MK_CONTROL,	CM_RECORD_STOP},
		/*
		{VK_UP,		MK_SHIFT,	CM_VOLUME_UP},
		{VK_DOWN,	MK_SHIFT,	CM_VOLUME_DOWN},
		{VK_UP,		MK_CONTROL,	CM_CHANNEL_UP},
		{VK_DOWN,	MK_CONTROL,	CM_CHANNEL_DOWN},
		*/
	};
	int i;

	if (m_Message==WM_NULL || uMsg!=m_Message)
		return false;
	for (i=0;i<lengthof(KeyMap);i++) {
		if (KeyMap[i].Key==wParam && KeyMap[i].Modifier==lParam) {
			SendMessage(hwndMain,WM_COMMAND,KeyMap[i].Command,0);
			break;
		}
	}
	return true;
}


class CKeyHook *pKeyHook=NULL;




LRESULT CALLBACK ViewWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_SIZE:
		DtvEngine.SetViewSize(LOWORD(lParam),HIWORD(lParam));
		return 0;

	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
	case WM_LBUTTONDBLCLK:
		{
			POINT pt;

			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			MapWindowPoints(hwnd,GetParent(hwnd),&pt,1);
			return SendMessage(GetParent(hwnd),uMsg,wParam,
														MAKELPARAM(pt.x,pt.y));
		}
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


static void SetChannelMenu(HMENU hmenu)
{
	int Count,i;
	TCHAR szText[MAX_CHANNEL_NAME+4];

	Count=GetMenuItemCount(hmenu);
	for (i=Count-1;i>=0;i--)
		DeleteMenu(hmenu,i,MF_BYPOSITION);
	for (i=0;i<ChannelList.NumChannels();i++) {
		wsprintf(szText,TEXT("%d: %s"),ChannelList.GetChannelNo(i),
													ChannelList.GetName(i));
		AppendMenu(hmenu,MFT_STRING | MFS_ENABLED
				| (i!=0 && i%12==0?MF_MENUBREAK:0),CM_CHANNEL_FIRST+i,szText);
	}
}


static void SetSpaceMenu(HMENU hmenu)
{
	int Count,i;
	LPCTSTR pszName;

	Count=GetMenuItemCount(hmenu);
	for (i=Count-1;i>=0;i--)
		DeleteMenu(hmenu,i,MF_BYPOSITION);
	NumSpaces=0;
	for (i=0;(pszName=DtvEngine.m_BonSrcDecoder.GetSpaceName(i))!=NULL;i++) {
		AppendMenu(hmenu,MFT_STRING | MFS_ENABLED,CM_SPACE_FIRST+i,pszName);
		NumSpaces++;
	}
	if (NumSpaces>0)
		CheckMenuRadioItem(hmenu,CM_SPACE_FIRST,CM_SPACE_FIRST+NumSpaces-1,
									CM_SPACE_FIRST+CurrentSpace,MF_BYCOMMAND);
}


static void PopupMenu(int x,int y)
{
	TrackPopupMenu(GetSubMenu(hmenuMain,0),TPM_RIGHTBUTTON,x,y,0,hwndMain,NULL);
}


class MyDtvEngineHandler : public CDtvEngineHandler
{
	const DWORD OnDtvEngineEvent(CDtvEngine *pEngine,const DWORD dwEventID,
																PVOID pParam);
};


static MyDtvEngineHandler DtvEngineHandler;


const DWORD MyDtvEngineHandler::OnDtvEngineEvent(CDtvEngine *pEngine,
											const DWORD dwEventID,PVOID pParam)
{
	CProgManager *pProgManager=static_cast<CProgManager*>(pParam);
	int NumServices,i;
	TCHAR szServiceName[1024];
	LPTSTR *ppszList;

	NumServices=pProgManager->GetServiceNum();
	ppszList=new LPTSTR[NumServices];
	for (i=0;i<NumServices;i++) {
		if (!pProgManager->GetServiceName(szServiceName,i))
			lstrcpy(szServiceName,TEXT("T[rX擾..."));
		ppszList[i]=new TCHAR[lstrlen(szServiceName)+1];
		lstrcpy(ppszList[i],szServiceName);
	}
	PostMessage(hwndMain,WM_APP,MAKEWPARAM(pEngine->GetService(),NumServices),
															(LPARAM)ppszList);
	return 0;
}


LRESULT CALLBACK MainWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		{
			hwndView=CreateWindowEx(WS_EX_CLIENTEDGE,VIEW_WINDOW_CLASS,NULL,
									WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
									0,0,0,0,hwnd,(HMENU)IDC_VIEW,hInst,NULL);
			Status.Create(hwnd,IDC_STATUS,WS_CHILD | WS_VISIBLE,
															WS_EX_CLIENTEDGE);
			Status.SetSingleText(TEXT("N..."));
			hmenuMain=LoadMenu(hInst,MAKEINTRESOURCE(IDM_MENU));
			CheckMenuItem(hmenuMain,CM_FULLSCREEN,
					MF_BYCOMMAND | (fFullscreen?MFS_CHECKED:MFS_UNCHECKED));
			CheckMenuItem(hmenuMain,CM_ALWAYSONTOP,
					MF_BYCOMMAND | (fAlwaysOnTop?MFS_CHECKED:MFS_UNCHECKED));
			CheckMenuRadioItem(hmenuMain,CM_STEREO_THROUGH,CM_STEREO_RIGHT,
							CM_STEREO_THROUGH+CurrentStereoMode,MF_BYCOMMAND);
			CheckMenuItem(hmenuMain,CM_ADDRECORDTIME,
					MF_BYCOMMAND | (fAddRecordTime?MFS_CHECKED:MFS_UNCHECKED));
		}
		return 0;

	case WM_SIZE:
		{
			RECT rc;
			int Height;

			Status.GetRect(&rc);
			Height=HIWORD(lParam)-(rc.bottom-rc.top);
			MoveWindow(hwndView,0,0,LOWORD(lParam),Height,TRUE);
			Status.Move(0,Height,LOWORD(lParam),rc.bottom-rc.top);
			Status.UpdateItem(STATUS_ITEM_VIDEOSIZE);
		}
		return 0;

	case WM_TIMER:
		{
			WORD Width,Height;
			int NumChannels;

			if (DtvEngine.GetVideoSize(&Width,&Height)) {
				if (Width!=VideoWidth || Height!=VideoHeight) {
					VideoWidth=Width;
					VideoHeight=Height;
					Status.UpdateItem(STATUS_ITEM_VIDEOSIZE);
				}
			}
			// ԈႢT1
			//NumChannels=DtvEngine.GetAudioChannelNum();
			NumChannels=DtvEngine.GetAudioCahnnelNum();
			if (NumChannels>0) {
				if (NumChannels!=CurrentNumAudioChannels) {
					CurrentStereoMode=0;
					DtvEngine.SetStereoMode(0);
					CurrentNumAudioChannels=NumChannels;
					Status.UpdateItem(STATUS_ITEM_AUDIOCHANNEL);
				}
			}
		}
		return 0;

	case WM_RBUTTONDOWN:
		{
			POINT pt;

			if (!fFullscreen) {
				pt.x=GET_X_LPARAM(lParam);
				pt.y=GET_Y_LPARAM(lParam);
				ClientToScreen(hwnd,&pt);
			} else
				GetCursorPos(&pt);
			PopupMenu(pt.x,pt.y);
		}
		return 0;

	case WM_LBUTTONDOWN:
		ptDragStartPos.x=GET_X_LPARAM(lParam);
		ptDragStartPos.y=GET_Y_LPARAM(lParam);
		ClientToScreen(hwnd,&ptDragStartPos);
		GetWindowRect(hwnd,&rcDragStart);
		SetCapture(hwnd);
		return 0;

	case WM_LBUTTONUP:
		if (GetCapture()==hwnd)
			ReleaseCapture();
		return 0;

	case WM_MOUSEMOVE:
		if (GetCapture()==hwnd) {
			POINT pt;

			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			ClientToScreen(hwnd,&pt);
			MoveWindow(hwnd,rcDragStart.left+(pt.x-ptDragStartPos.x),
							rcDragStart.top+(pt.y-ptDragStartPos.y),
							rcDragStart.right-rcDragStart.left,
							rcDragStart.bottom-rcDragStart.top,TRUE);
		}
		return 0;

	case WM_LBUTTONDBLCLK:
		SendMessage(hwnd,WM_COMMAND,CM_FULLSCREEN,0);
		return 0;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case CM_ZOOM_25:
		case CM_ZOOM_33:
		case CM_ZOOM_50:
		case CM_ZOOM_66:
		case CM_ZOOM_75:
		case CM_ZOOM_100:
		case CM_ZOOM_150:
		case CM_ZOOM_200:
			{
				static const int ZoomList[] = {25,33,50,66,75,100,150,200};
				WORD Width,Height;

				if (fFullscreen)
					SendMessage(hwnd,WM_COMMAND,CM_FULLSCREEN,0);
				if (DtvEngine.GetVideoSize(&Width,&Height)) {
					int w,h;
					BYTE XAspect,YAspect;
					int Zoom=ZoomList[LOWORD(wParam)-CM_ZOOM_FIRST];
					RECT rc,rcStatus;

					VideoWidth=w=Width;
					VideoHeight=h=Height;
					if (DtvEngine.GetVideoAspectRatio(&XAspect,&YAspect))
						AdjustAspect(&w,&h,XAspect,YAspect);
					GetWindowRect(hwndView,&rc);
					rc.right=rc.left+w*Zoom/100+GetSystemMetrics(SM_CXEDGE)*2;
					rc.bottom=rc.top+h*Zoom/100+GetSystemMetrics(SM_CYEDGE)*2;
					Status.GetRect(&rcStatus);
					rc.bottom+=rcStatus.bottom-rcStatus.top;
					AdjustWindowRectEx(&rc,GetWindowStyle(hwnd),FALSE,
													GetWindowExStyle(hwnd));
					MoveWindow(hwnd,rc.left,rc.top,
									rc.right-rc.left,rc.bottom-rc.top,TRUE);
				}
			}
			return 0;

		case CM_FULLSCREEN:
			if (CurrentChannel<0)
				return 0;
			if (fAlwaysOnTop)
				SetWindowPos(hwnd,fFullscreen?HWND_TOPMOST:HWND_NOTOPMOST,
											0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
			if (DtvEngine.SwitchFullscreen()) {
				fFullscreen=!fFullscreen;
				CheckMenuItem(hmenuMain,CM_FULLSCREEN,
					MF_BYCOMMAND | (fFullscreen?MFS_CHECKED:MFS_UNCHECKED));
			} else {
				if (fAlwaysOnTop)
					SetWindowPos(hwnd,fFullscreen?HWND_NOTOPMOST:HWND_TOPMOST,
											0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
			}
			return 0;

		case CM_ALWAYSONTOP:
			fAlwaysOnTop=!fAlwaysOnTop;
			SetWindowPos(hwnd,fAlwaysOnTop?HWND_TOPMOST:HWND_NOTOPMOST,
											0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
			CheckMenuItem(hmenuMain,CM_ALWAYSONTOP,
					MF_BYCOMMAND | (fAlwaysOnTop?MFS_CHECKED:MFS_UNCHECKED));
			return 0;

		case CM_VOLUME_UP:
		case CM_VOLUME_DOWN:
			{
				bool fRestore=false;
				int Volume;

				if (fMute) {
					fMute=false;
					CheckMenuItem(hmenuMain,CM_VOLUME_MUTE,
												MF_BYCOMMAND | MFS_UNCHECKED);
					fRestore=true;
				}
				if (LOWORD(wParam)==CM_VOLUME_UP) {
					Volume=CurrentVolume+5;
					if (Volume>MAX_VOLUME)
						Volume=MAX_VOLUME;
				} else {
					Volume=CurrentVolume-5;
					if (Volume<0)
						Volume=0;
				}
				if (Volume!=CurrentVolume || fRestore) {
					DtvEngine.SetVolume(LevelToDeciBel(Volume));
					CurrentVolume=Volume;
					Status.UpdateItem(STATUS_ITEM_VOLUME);
				}
			}
			return 0;

		case CM_VOLUME_MUTE:
			{
				int Volume;

				fMute=!fMute;
				DtvEngine.SetVolume(LevelToDeciBel(fMute?0:CurrentVolume));
				Status.UpdateItem(STATUS_ITEM_VOLUME);
				CheckMenuItem(hmenuMain,CM_VOLUME_MUTE,
							MF_BYCOMMAND | (fMute?MFS_CHECKED:MFS_UNCHECKED));
			}
			return 0;

		case CM_STEREO_THROUGH:
		case CM_STEREO_LEFT:
		case CM_STEREO_RIGHT:
		case CM_STEREOMODE:
			if (LOWORD(wParam)==CM_STEREOMODE)
				CurrentStereoMode=(CurrentStereoMode+1)%3;
			else
				CurrentStereoMode=LOWORD(wParam)-CM_STEREO_THROUGH;
			DtvEngine.SetStereoMode(CurrentStereoMode);
			CheckMenuRadioItem(hmenuMain,CM_STEREO_THROUGH,CM_STEREO_RIGHT,
							CM_STEREO_THROUGH+CurrentStereoMode,MF_BYCOMMAND);
			Status.UpdateItem(STATUS_ITEM_AUDIOCHANNEL);
			return 0;

		case CM_RESET:
			DtvEngine.ResetEngine();
			return 0;

		case CM_DECODERPROPERTY:
			// ԈႢT2
			//DtvEngine.DisplayVideoDecoderProperty(hwnd);
			DtvEngine.DisplayVideoDecorderProperty(hwnd);
			return 0;

		case CM_RECORD:
		case CM_RECORD_START:
		case CM_RECORD_STOP:
			if (CurrentChannel<0)
				return 0;
			if (LOWORD(wParam)==CM_RECORD_START) {
				if (fRecording)
					return 0;
			} else if (LOWORD(wParam)==CM_RECORD_STOP) {
				if (!fRecording)
					return 0;
			}
			if (fRecording) {
				DtvEngine.m_FileWriter.CloseFile();
				fRecording=false;
			} else {
				TCHAR szFileName[MAX_PATH];

				lstrcpy(szFileName,szRecordFileName);
				if (fAddRecordTime) {
					SYSTEMTIME st;

					if (lstrlen(szFileName)+15>=MAX_PATH) {
						MessageBox(hwnd,
							TEXT("t@Cētł܂B"),
									TEXT("߂"),MB_OK | MB_ICONEXCLAMATION);
						return 0;
					}
					GetLocalTime(&st);
					wsprintf(PathFindExtension(szFileName),
										TEXT("%04d%02d%02d_%02d%02d%02d%s"),
										st.wYear,st.wMonth,st.wDay,
										st.wHour,st.wMinute,st.wSecond,
										PathFindExtension(szRecordFileName));
				}
				if (!DtvEngine.m_FileWriter.OpenFile(szFileName)) {
					MessageBox(hwnd,TEXT("t@CJ܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
					return 0;
				}
				fRecording=true;
			}
			Status.UpdateItem(STATUS_ITEM_RECORD);
			return 0;

		case CM_RECORDFILENAME:
			{
				OPENFILENAME ofn;
				TCHAR szFileName[MAX_PATH];

				lstrcpy(szFileName,szRecordFileName);
				ofn.lStructSize=sizeof(OPENFILENAME);
				ofn.hwndOwner=hwnd;
				ofn.lpstrFilter=
					TEXT("TSt@C(*.ts)\0*.ts\0ׂẴt@C\0*.*\0");
				ofn.lpstrCustomFilter=NULL;
				ofn.nFilterIndex=1;
				ofn.lpstrFile=szFileName;
				ofn.nMaxFile=lengthof(szFileName);
				ofn.lpstrFileTitle=NULL;
				ofn.lpstrInitialDir=NULL;
				ofn.lpstrTitle=TEXT("ۑt@C");
				ofn.Flags=OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
				ofn.lpstrDefExt=TEXT("ts");
#if _WIN32_WINNT>=0x500
				ofn.pvReserved=NULL;
				ofn.dwReserved=0;
				ofn.FlagsEx=0;
#endif
				if (GetSaveFileName(&ofn))
					lstrcpy(szRecordFileName,szFileName);
			}
			return 0;

		case CM_ADDRECORDTIME:
			fAddRecordTime=!fAddRecordTime;
			CheckMenuItem(hmenuMain,CM_ADDRECORDTIME,
					MF_BYCOMMAND | (fAddRecordTime?MFS_CHECKED:MFS_UNCHECKED));
			return 0;

		case CM_EXIT:
			SendMessage(hwnd,WM_CLOSE,0,0);
			return 0;

		case CM_CHANNEL_UP:
		case CM_CHANNEL_DOWN:
			if (CurrentChannel>=0) {
				int Channel;
				int i,j;

				Channel=ChannelList.GetChannelNo(CurrentChannel)-1;
				for (i=0;i<12;i++) {
					if (LOWORD(wParam)==CM_CHANNEL_UP) {
						Channel=(Channel+1)%12;
					} else {
						if (Channel>0)
							Channel--;
						else
							Channel=11;
					}
					for (j=0;j<ChannelList.NumChannels();j++) {
						if (ChannelList.GetChannelNo(j)==Channel+1)
							break;
					}
					if (j<ChannelList.NumChannels())
						break;
				}
				SendMessage(hwnd,WM_COMMAND,CM_CHANNELNO_FIRST+Channel,0);
			} else
				SendMessage(hwnd,WM_COMMAND,CM_CHANNELNO_FIRST,0);
			return 0;

		case CM_MENU:
			{
				POINT pt;

				pt.x=0;
				pt.y=0;
				ClientToScreen(hwndView,&pt);
				PopupMenu(pt.x,pt.y);
			}
			return 0;

		default:
			if (LOWORD(wParam)>=CM_CHANNELNO_FIRST
										&& LOWORD(wParam)<=CM_CHANNELNO_LAST) {
				int No=LOWORD(wParam)-CM_CHANNELNO_FIRST;
				int i;

				for (i=0;i<ChannelList.NumChannels();i++) {
					if (ChannelList.GetChannelNo(i)==No+1) {
						SendMessage(hwnd,WM_COMMAND,CM_CHANNEL_FIRST+i,0);
						break;
					}
				}
			}
			if (LOWORD(wParam)>=CM_CHANNEL_FIRST
										&& LOWORD(wParam)<=CM_CHANNEL_LAST) {
				int Channel=LOWORD(wParam)-CM_CHANNEL_FIRST,Space;

				Space=ChannelList.GetSpace(Channel);
				if (Space<0)
					Space=CurrentSpace;
				if ((Channel!=CurrentChannel || Space!=CurrentSpace)
						&& DtvEngine.SetChannel(Space,
							ChannelList.GetChannel(Channel)-FIRST_CHANNEL)) {
					CurrentSpace=Space;
					CurrentChannel=Channel;
					Status.UpdateItem(STATUS_ITEM_CHANNEL);
					CheckMenuRadioItem(hmenuMain,CM_CHANNEL_FIRST,
								CM_CHANNEL_FIRST+ChannelList.NumChannels()-1,
								CM_CHANNEL_FIRST+CurrentChannel,MF_BYCOMMAND);
					CheckMenuRadioItem(hmenuMain,CM_SPACE_FIRST,
								CM_SPACE_FIRST+NumSpaces-1,
								CM_SPACE_FIRST+CurrentSpace,MF_BYCOMMAND);
				}
				return 0;
			}
			if (LOWORD(wParam)>=CM_SERVICE_FIRST
										&& LOWORD(wParam)<=CM_SERVICE_LAST) {
				CurrentService=LOWORD(wParam)-CM_SERVICE_FIRST;
				DtvEngine.SetService(CurrentService);
				CheckMenuRadioItem(hmenuMain,CM_SERVICE_FIRST,
					CM_SERVICE_FIRST+GetMenuItemCount(
						GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_SERVICE))-1,
								CM_CHANNEL_FIRST+CurrentService,MF_BYCOMMAND);
				return 0;
			}
			if (LOWORD(wParam)>=CM_SPACE_FIRST
											&& LOWORD(wParam)<=CM_SPACE_LAST) {
				int Space=LOWORD(wParam)-CM_SPACE_FIRST;

				if (Space!=CurrentSpace
						&& DtvEngine.SetChannel(Space,
									ChannelList.GetChannel(0)-FIRST_CHANNEL)) {
					CurrentSpace=Space;
					CurrentChannel=0;
					Status.UpdateItem(STATUS_ITEM_CHANNEL);
					CheckMenuRadioItem(hmenuMain,CM_SPACE_FIRST,
								CM_SPACE_FIRST+NumSpaces-1,
								CM_SPACE_FIRST+CurrentSpace,MF_BYCOMMAND);
					CheckMenuRadioItem(hmenuMain,CM_CHANNEL_FIRST,
								CM_CHANNEL_FIRST+ChannelList.NumChannels()-1,
								CM_CHANNEL_FIRST+CurrentChannel,MF_BYCOMMAND);
				}
				return 0;
			}
		}
		return 0;

	case WM_SYSCOMMAND:
		switch (wParam) {
		case SC_MONITORPOWER:
			if (fNoMonitorLowPower)
				return TRUE;
			break;
		}
		break;

	case WM_APP:
		{
			HMENU hmenu=GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_SERVICE);
			int NumServices=HIWORD(wParam);
			LPTSTR *ppszList=(LPTSTR*)lParam;
			int Count,i;

			Count=GetMenuItemCount(hmenu);
			for (i=Count-1;i>=0;i--)
				DeleteMenu(hmenu,i,MF_BYPOSITION);
			for (i=0;i<NumServices;i++) {
				AppendMenu(hmenu,MFT_STRING | MFS_ENABLED,CM_SERVICE_FIRST+i,
																ppszList[i]);
				delete [] ppszList[i];
			}
			delete [] ppszList;
			CurrentService=LOWORD(wParam);
			CheckMenuRadioItem(hmenuMain,CM_SERVICE_FIRST,
				CM_SERVICE_FIRST+NumServices-1,CM_CHANNEL_FIRST+CurrentService,
																MF_BYCOMMAND);
		}
		return 0;

	case WM_DESTROY:
		{
			delete pKeyHook;
			pKeyHook=NULL;

			WINDOWPLACEMENT wc;

			wc.length=sizeof(WINDOWPLACEMENT);
			GetWindowPlacement(hwnd,&wc);
			WindowLeft=wc.rcNormalPosition.left;
			WindowTop=wc.rcNormalPosition.top;
			WindowWidth=wc.rcNormalPosition.right-wc.rcNormalPosition.left;
			WindowHeight=wc.rcNormalPosition.bottom-wc.rcNormalPosition.top;
			fWindowMaximize=wc.showCmd==SW_MAXIMIZE;

			KillTimer(hwnd,1);
			if (hDriverLib!=NULL) {
				DtvEngine.CloseEngine();
				FreeLibrary(hDriverLib);
			}
			if (CurrentChannel>=0) {
				OldChannel=ChannelList.GetChannel(CurrentChannel);
				OldSpace=ChannelList.GetSpace(CurrentChannel);
			} else {
				OldChannel=0;
				OldSpace=-1;
			}
			DestroyMenu(hmenuMain);
			PostQuitMessage(0);
		}
		return 0;

	default:
		if (pKeyHook!=NULL && pKeyHook->TranslateMessage(uMsg,wParam,lParam))
			return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


static void ParseCommandLine(LPCWSTR pszCmdLine)
{
	LPWSTR *ppszArgList;
	int Args;

	ppszArgList=CommandLineToArgvW(pszCmdLine,&Args);
	if (ppszArgList!=NULL) {
		int i;

		for (i=0;i<Args;i++) {
			if (ppszArgList[i][0]=='/' || ppszArgList[i][0]=='-') {
				switch (ppszArgList[i][1]) {
				case 'd':
				case 'D':
					i++;
					if (i<Args)
						lstrcpyn(szDriverFileName,ppszArgList[i],
												lengthof(szDriverFileName));
					break;
				case 'n':
				case 'N':
					if (ppszArgList[i][2]=='d' || ppszArgList[i][2]=='D')
						fNoDescramble=true;
				}
			}
		}
		LocalFree(ppszArgList);
	}
}


class CAppMutex {
	HANDLE m_hMutex;
	bool m_fAlreadyExists;
public:
	CAppMutex();
	~CAppMutex();
	bool AlreadyExists() const { return m_fAlreadyExists; }
};

CAppMutex::CAppMutex()
{
	m_hMutex=CreateMutex(NULL,TRUE,TEXT("HDUSTest Mutex"));
	m_fAlreadyExists=m_hMutex!=NULL && GetLastError()==ERROR_ALREADY_EXISTS;
}

CAppMutex::~CAppMutex()
{
	if (m_hMutex!=NULL) {
		if (!m_fAlreadyExists)
			ReleaseMutex(m_hMutex);
		CloseHandle(m_hMutex);
	}
}


int APIENTRY _tWinMain(HINSTANCE hInstance,HINSTANCE /*hPrevInstance*/,
												LPTSTR pszCmdLine,int nCmdShow)
{
	CAppMutex Mutex;

	// Ñ`FbN
	if (Mutex.AlreadyExists()) {
		HWND hwnd;

		hwnd=FindWindow(MAIN_WINDOW_CLASS,TITLE_TEXT);
		if (IsWindow(hwnd)) {
			SetForegroundWindow(hwnd);
		} else {
			MessageBox(NULL,
				TEXT("HDUSTest ͊ɋNĂ܂B\r\n")
				TEXT("EBhEȂꍇ̓^XN}l[WɉBĂ܂̂\r\n")
				TEXT("IĂB"),TITLE_TEXT,
												MB_OK | MB_ICONEXCLAMATION);
		}
		return FALSE;
	}

	hInst=hInstance;

	TCHAR szModuleDir[MAX_PATH];
	TCHAR szChannelListFileName[MAX_PATH];

	GetModuleFileName(NULL,szModuleDir,MAX_PATH);
	lstrcpy(szIniFileName,szModuleDir);
	PathRenameExtension(szIniFileName,TEXT(".ini"));
	lstrcpy(szChannelListFileName,szModuleDir);
	PathRenameExtension(szChannelListFileName,TEXT(".ch"));
	*(PathFindFileName(szModuleDir)-1)='\0';
	PathCombine(szRecordFileName,szModuleDir,TEXT("Record.ts"));

	LoadSettings();
	if (pszCmdLine[0]!='\0')
		ParseCommandLine(pszCmdLine);

	if (szDriverFileName[0]=='\0')
		lstrcpy(szDriverFileName,TEXT("BonDriver_HDUS.dll"));

	LoadChannelList(szChannelListFileName);

	WNDCLASS wc;

	wc.style=0;
	wc.lpfnWndProc=MainWndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON));
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=(HBRUSH)(COLOR_3DFACE+1);
	wc.lpszMenuName=NULL;
	wc.lpszClassName=MAIN_WINDOW_CLASS;
	if (RegisterClass(&wc)==0) {
		return 0;
	}
	wc.style=0;
	wc.lpfnWndProc=ViewWndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=CreateSolidBrush(RGB(0,0,0));
	wc.lpszMenuName=NULL;
	wc.lpszClassName=VIEW_WINDOW_CLASS;
	if (RegisterClass(&wc)==0) {
		return 0;
	}
	if (!CStatusView::Init()) {
		return 0;
	}

	/*
	INITCOMMONCONTROLSEX iccex;

	iccex.dwSize=sizeof(INITCOMMONCONTROLSEX);
	iccex.dwICC=ICC_WIN95_CLASSES;
	InitCommonControlsEx(&iccex);
	*/

	hwndMain=CreateWindowEx(fAlwaysOnTop?WS_EX_TOPMOST:0,MAIN_WINDOW_CLASS,
		TITLE_TEXT,
		WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN
			| (fWindowMaximize?WS_MAXIMIZE:0),
		WindowLeft,WindowTop,WindowWidth,WindowHeight,NULL,NULL,hInst,NULL);
	if (hwndMain==NULL) {
		MessageBox(NULL,TEXT("EBhE쐬ł܂B"),NULL,
														MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	ShowWindow(hwndMain,nCmdShow);
	UpdateWindow(hwndMain);

	hDriverLib=LoadLibrary(szDriverFileName);
	if (hDriverLib==NULL) {
		MessageBox(hwndMain,TEXT("hCo[hł܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
	} else {
		if (DtvEngine.OpenEngine(&DtvEngineHandler,hwndView,hwndMain,
												hDriverLib,!fNoDescramble)) {
			DtvEngine.EnablePreview();
			DtvEngine.SetVolume(LevelToDeciBel(CurrentVolume));
		}
		if (ChannelList.NumChannels()==0) {
			int i;
			LPCTSTR pszName;

			for (i=0;(pszName=DtvEngine.m_BonSrcDecoder.GetChannelName(0,i))
																	!=NULL;i++)
				ChannelList.AddChannel(-1,FIRST_CHANNEL+i,FIRST_CHANNEL+i,
																	pszName);
		}
		SetChannelMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_CHANNEL));
		SetSpaceMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_SPACE));
		SetTimer(hwndMain,1,500,NULL);
	}

	if (!fNoKeyHook && !fNoRemoteController) {
		pKeyHook=new CKeyHook;
		pKeyHook->BeginHook();
	}

	if (!fNoRemoteController)
		hAccel=LoadAccelerators(hInst,
							MAKEINTRESOURCE(fNoKeyHook?IDA_ACCEL:IDA_ACCEL2));
	else
		hAccel=NULL;

	if (fNoScreenSaver) {
		if (!SystemParametersInfo(SPI_GETSCREENSAVEACTIVE,0,
														&fScreenSaverActive,0))
			fScreenSaverActive=FALSE;
		SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,FALSE,NULL,0);
	}

	Status.SetSingleText(NULL);

	if (fRestoreChannel && OldChannel>0) {
		int i;

		for (i=0;i<ChannelList.NumChannels();i++) {
			if (ChannelList.GetChannel(i)==OldChannel
					&& ChannelList.GetSpace(i)==OldSpace) {
				SendMessage(hwndMain,WM_COMMAND,CM_CHANNELNO_FIRST+i,0);
				break;
			}
		}
	}

	MSG msg;

	while (GetMessage(&msg,NULL,0,0)) {
		if (hAccel==NULL || !TranslateAccelerator(hwndMain,hAccel,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	if (fNoScreenSaver && fScreenSaverActive)
		SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,TRUE,NULL,0);

	SaveSettings();

	return msg.wParam;
}
